VERSION 5.00
Object = "{CDE57A40-8B86-11D0-B3C6-00A0C90AEA82}#1.0#0"; "MSDATGRD.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmData 
   Caption         =   "Returned Data"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   Icon            =   "frmData.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.StatusBar staStatusBar 
      Align           =   2  'Align Bottom
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Top             =   2775
      Width           =   4680
      _ExtentX        =   8255
      _ExtentY        =   556
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin MSDataGridLib.DataGrid grdData 
      Height          =   1575
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   2778
      _Version        =   393216
      HeadLines       =   1
      RowHeight       =   15
      BeginProperty HeadFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ColumnCount     =   2
      BeginProperty Column00 
         DataField       =   ""
         Caption         =   ""
         BeginProperty DataFormat {6D835690-900B-11D0-9484-00A0C91110ED} 
            Type            =   0
            Format          =   ""
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   0
         EndProperty
      EndProperty
      BeginProperty Column01 
         DataField       =   ""
         Caption         =   ""
         BeginProperty DataFormat {6D835690-900B-11D0-9484-00A0C91110ED} 
            Type            =   0
            Format          =   ""
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   0
         EndProperty
      EndProperty
      SplitCount      =   1
      BeginProperty Split0 
         BeginProperty Column00 
         EndProperty
         BeginProperty Column01 
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    staStatusBar.Panels.Clear
    staStatusBar.Panels.Add 1, "StoredProcedureName", , sbrText
    staStatusBar.Panels(1).AutoSize = sbrSpring
    staStatusBar.Panels(1).ToolTipText = "Stored Procedure"
    staStatusBar.Panels.Add 2, "RecordCount", , sbrText
    staStatusBar.Panels(2).MinWidth = 3
    staStatusBar.Panels(2).AutoSize = sbrContents
    staStatusBar.Panels(2).ToolTipText = "Record Count"
    staStatusBar.Panels.Add 3, "ColumnName", "          ", sbrText
    staStatusBar.Panels(3).MinWidth = 30
    staStatusBar.Panels(3).AutoSize = sbrContents
    staStatusBar.Panels(3).ToolTipText = "Selected Field Name"
    staStatusBar.Panels.Add 4, "ColumnDataType", "          ", sbrText
    staStatusBar.Panels(4).MinWidth = 30
    staStatusBar.Panels(4).AutoSize = sbrContents
    staStatusBar.Panels(4).ToolTipText = "Selected Field Type (Size)"
    staStatusBar.Panels.Add 5, "Editable", "          ", sbrText
    staStatusBar.Panels(5).MinWidth = 30
    staStatusBar.Panels(5).AutoSize = sbrContents
    staStatusBar.Panels(5).ToolTipText = "Selected Field Editable"
End Sub

Private Sub Form_Resize()
' Local Variables
    Dim lngHeight As Long

    lngHeight = Me.ScaleHeight - Me.staStatusBar.Height
    If lngHeight <= 0 Then
        lngHeight = 1
    End If
    Me.grdData.Move 0, 0, Me.ScaleWidth, lngHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set Me.grdData.DataSource = Nothing
End Sub

Private Sub grdData_GotFocus()
    UpdateStatusBar
End Sub

Private Sub grdData_RowColChange(LastRow As Variant, ByVal LastCol As Integer)
    UpdateStatusBar
End Sub

Private Sub UpdateStatusBar()
    Dim rsRecordset As ADODB.Recordset
    Dim strEditableStatus As String
    Dim lngFieldAttribute As Long
    
    Set rsRecordset = grdData.DataSource
    staStatusBar.Panels("ColumnName").Text = _
        rsRecordset.Fields(grdData.Columns(grdData.Col).DataField).Name & " "
    staStatusBar.Panels("ColumnDataType").Text = _
        AdoTypeToString(rsRecordset.Fields(grdData.Columns(grdData.Col).DataField).Type) & _
        "(" & rsRecordset.Fields(grdData.Columns(grdData.Col).DataField).DefinedSize & ") "
    
    Debug.Print rsRecordset.Fields(grdData.Col).Attributes
    Debug.Print rsRecordset.Fields(grdData.Col).Attributes And adFldUpdatable
    Debug.Print rsRecordset.Fields(grdData.Col).Attributes And adFldUnknownUpdatable
    lngFieldAttribute = rsRecordset.Fields(grdData.Col).Attributes
    If (lngFieldAttribute And adFldUpdatable) = adFldUpdatable Then
        strEditableStatus = "Editable"
    ElseIf (lngFieldAttribute And adFldUnknownUpdatable) = adFldUnknownUpdatable Then
        strEditableStatus = "Unknown"
    Else
        strEditableStatus = "Read-Only"
    End If
    staStatusBar.Panels("Editable").Text = strEditableStatus & " "
        
End Sub

Private Function AdoTypeToString(ByVal AdoType As ADODB.DataTypeEnum) As String

    Select Case AdoType
        Case adArray
            AdoTypeToString = "adArray"
        Case adBigInt
            AdoTypeToString = "adBigInt"
        Case adBinary
            AdoTypeToString = "adBinary"
        Case adBoolean
            AdoTypeToString = "adBoolean"
'        Case adByRef
'            AdoTypeToString = "adByRef"
        Case adBSTR
            AdoTypeToString = "adBSTR"
        Case adChar
            AdoTypeToString = "adChar"
        Case adCurrency
            AdoTypeToString = "adCurrency"
        Case adDate
            AdoTypeToString = "adDate"
        Case adDBDate
            AdoTypeToString = "adDBDate"
        Case adDBTime
            AdoTypeToString = "adDBTime"
        Case adDBTimeStamp
            AdoTypeToString = "adDBTimeStamp"
        Case adDecimal
            AdoTypeToString = "adDecimal"
        Case adDouble
            AdoTypeToString = "adDouble"
        Case adEmpty
            AdoTypeToString = "adEmpty"
        Case adError
            AdoTypeToString = "adError"
        Case adGUID
            AdoTypeToString = "adGUID"
        Case adIDispatch
            AdoTypeToString = "adIDispatch"
        Case adInteger
            AdoTypeToString = "adInteger"
        Case adIUnknown
            AdoTypeToString = "adIUnknown"
        Case adLongVarBinary
            AdoTypeToString = "adLongVarBinary"
        Case adLongVarChar
            AdoTypeToString = "adLongVarChar"
        Case adLongVarWChar
            AdoTypeToString = "adLongVarWChar"
        Case adNumeric
            AdoTypeToString = "adNumeric"
        Case adSingle
            AdoTypeToString = "adSingle"
        Case adSmallInt
            AdoTypeToString = "adSmallInt"
        Case adTinyInt
            AdoTypeToString = "adTinyInt"
        Case adUnsignedBigInt
            AdoTypeToString = "adUnsignedBigInt"
        Case adUnsignedInt
            AdoTypeToString = "adUnsignedInt"
        Case adUnsignedSmallInt
            AdoTypeToString = "adUnsignedSmallInt"
        Case adUnsignedTinyInt
            AdoTypeToString = "adUnsignedTinyInt"
        Case adUserDefined
            AdoTypeToString = "adUserDefined"
        Case adVarBinary
            AdoTypeToString = "adVarBinary"
        Case adVarChar
            AdoTypeToString = "adVarChar"
        Case adVariant
            AdoTypeToString = "adVariant"
'        Case adVector
'            AdoTypeToString = "adVector"
        Case adVarWChar
            AdoTypeToString = "adVarWChar"
        Case adWChar
            AdoTypeToString = "adWChar"
        Case Else
            AdoTypeToString = "Unknown"
    End Select
    
End Function

