VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Stored Procedure Tester"
   ClientHeight    =   1380
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6675
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1380
   ScaleWidth      =   6675
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboStoredProcedure 
      Height          =   315
      ItemData        =   "frmMain.frx":74F2
      Left            =   1560
      List            =   "frmMain.frx":74FC
      TabIndex        =   3
      Top             =   480
      Width           =   5055
   End
   Begin VB.CommandButton cmdGetRecordset 
      Caption         =   "Get Recordset"
      Default         =   -1  'True
      Height          =   375
      Left            =   2550
      TabIndex        =   4
      Top             =   900
      Width           =   1575
   End
   Begin VB.TextBox txtConnectionString 
      Height          =   315
      Left            =   1560
      TabIndex        =   1
      Text            =   "Provider=SQLOLEDB;Data Source=IS12;Initial Catalog=MchTest;Integrated Security=SSPI;NETWORK=DBMSSOCN;APP=Editable ADO Constants;"
      Top             =   120
      Width           =   5055
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Stored Procedure:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   1290
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Connection String:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1305
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdGetRecordset_Click()

    Dim cnDbConnection As ADODB.Connection
    Dim rsRecordset As ADODB.Recordset
    Dim strErrorMessageHeader As String
    Dim frmNewDataForm As frmData

    On Error GoTo ErrorHandler
    
    strErrorMessageHeader = "Error Creating Database Connection"
    
    Set cnDbConnection = New ADODB.Connection
    cnDbConnection.CursorLocation = adUseClient
    cnDbConnection.Open Me.txtConnectionString.Text
    
    strErrorMessageHeader = "Error Executing Stored Procedure"
    
    Set rsRecordset = New ADODB.Recordset

    ' Execute query and get recordset
    rsRecordset.Open Me.cboStoredProcedure.Text, _
        cnDbConnection, adOpenForwardOnly, adLockBatchOptimistic, adCmdStoredProc

    ' Disconnect Recordset
    Set rsRecordset.ActiveConnection = Nothing
    
    strErrorMessageHeader = "Error Opening Data Form"
    
    Set frmNewDataForm = New frmData
    
    Set frmNewDataForm.grdData.DataSource = rsRecordset
    
    frmNewDataForm.staStatusBar.Panels("StoredProcedureName").Text = _
        Me.cboStoredProcedure.Text
    frmNewDataForm.staStatusBar.Panels("RecordCount").Text = _
        rsRecordset.RecordCount & " "
        
    frmNewDataForm.Show vbModeless
    
    Set cnDbConnection = Nothing
    Set rsRecordset = Nothing
    
    Exit Sub
    
ErrorHandler:

    MsgBox strErrorMessageHeader & vbCrLf & _
        Err.Number & ": " & Err.Description & vbCrLf & vbCrLf & Err.Source, _
        vbOKOnly Or vbExclamation, strErrorMessageHeader
    
    Set cnDbConnection = Nothing
    Set rsRecordset = Nothing
    
    Exit Sub

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Local Variables
    Dim frmForm As Form

    ' Begin
    For Each frmForm In Forms
        If Not frmForm Is Me Then
            Unload frmForm
        End If
    Next frmForm

End Sub
